use Time::Local;

$m_to_n{'Jan'}=0;
$m_to_n{'Feb'}=1;
$m_to_n{'Mar'}=2;
$m_to_n{'Apr'}=3;
$m_to_n{'May'}=4;
$m_to_n{'Jun'}=5;
$m_to_n{'Jul'}=6;
$m_to_n{'Aug'}=7;
$m_to_n{'Sep'}=8;
$m_to_n{'Oct'}=9;
$m_to_n{'Nov'}=10;
$m_to_n{'Dec'}=11;

# This function should always be used when exiting Log Scanner
sub quit_logscanner {
	close(TAILF);
	print STDERR "Logscanner Terminiated.\n";
	exit;
}

# This function converts our xhymzs format to seconds
# We're assuming that the time we're getting is correctly formatted
sub ourtime_to_seconds {
	(my $hours=0);
	(my $minutes=0);
	(my $seconds=0);
	(my $i);
	(my @buffer);

	@buffer=split(//,$_[0]);
	for($i=0;$buffer[$i] ne 'h';$i++) {
		$hours*=10;
		$hours+=$buffer[$i];
	}

	for($i++;$buffer[$i] ne 'm';$i++) {
		$minutes*=10;
		$minutes+=$buffer[$i];
	}

	for($i++;$buffer[$i] ne 's';$i++) {
		$seconds*=10;
		$seconds+=$buffer[$i];
	}

	return ($seconds + $minutes*60 + $hours*3600);
}

# This function converts seconds to our xhymzs format
# We're assuming that we're receiving seconds as an integer
sub seconds_to_ourtime {
	(my $hours=0);
	(my $minutes=0);
	(my $seconds=0);
	(my $i=0);

	$hours=int($_[0] / 3600);
	$i = $_[0] % 3600;

	$minutes=int($i/60);
	$seconds=$i % 60;

	return ($hours,$minutes,$seconds);
}

# This subroutine accepts a line from a log file and spits back a hash
# containing the month, day, time, host, process, and pid referenced
# in the log line.
sub head_parse {
	(my %rethash=());
	(my @yab=());
	(my @otherb=());
	(my @buffer=());
	(my $buffer="");
	(my $logline="");
	(my $pid="");
	(my $process="");
	(my $i);
	
	$buffer=$_[0];
	@buffer=split(/\s+/,$buffer);

	@otherb=split(/\[/,$buffer[4]);
# need this line in certain cases where no pid shows up
	@yab=split(/:/,$otherb[0]);
	$process=$yab[0];
	
	@otherb=split(//,$otherb[1]);

	for($i=0;$otherb[$i] ne ']' && $otherb[$i];$i++) {
		$pid.=$otherb[$i];
	}

	for($i=5;$buffer[$i];$i++) {
		$logline.="$buffer[$i] ";
	}

	$rethash{'month'}=$buffer[0];
	$rethash{'day'}=$buffer[1];
	$rethash{'time'}=$buffer[2];
	$rethash{'host'}=$buffer[3];
	$rethash{'process'}=$process;
	$rethash{'pid'}=$pid;
	$rethash{'logline'}=$logline;

	return %rethash;
	
}

# This function will parse a "logline" and spit back the epoch time.

sub to_epoch {
	(my %tmphash=&head_parse($_[0]));
	(my @currenttime=localtime(time));
	(my $currentyear=$currenttime[5]);
	(my $epoch=0);
	(my @clock=split(/:/,$tmphash{'time'}));

	$epoch=timelocal($clock[2],$clock[1],$clock[0],$tmphash{'day'},$m_to_n{$tmphash{'month'}},$currentyear);
   
	# Make sure that we're not near the turn of the year
	if(time < $epoch) {
		$epoch=timelocal($clock[2],$clock[1],$clock[0],$day,$month,($currentyear-1));
	}

	return $epoch;
}

1;
