# -*- Mode: Perl -*-
#
#   This file contains the modules that will search for and verify anomalies 
#   in log lines passed from the main engine.  Each module is a function 
#   that should return "0" for condition not met, or a non-zero for 
#   condition met.

sub mod_telnet_connect {   
	if ($logs[$_[0]]{'logline'} =~ /in.telnetd.*?connect from (.*?)$/) {   
		return $1;
	} else {
		return 0;   
	}   
}


sub mod_ftp_connect {   
	if ($logs[$_[0]]{'logline'} =~ /in.ftpd.*?connect from (.*?)$/) {   
		return $1;
	} else {   
		return 0;   
	}   
}


sub mod_rsh_connect {   
	if ($logs[$_[0]]{'logline'} =~ /in.rshd.*?connect from (.*?)$/) {   
		return $1;
	} else {   
		return 0;   
	}   
}

sub mod_rlogin_connect {   
	if ($logs[$_[0]]{'logline'} =~ /in.rlogind.*?connect from (.*?)$/) {   
		return $1;
	} else {   
		return 0;   
	}   
}

sub mod_finger_connect {   
	if ($logs[$_[0]]{'logline'} =~ /in.fingerd.*?connect from (.*?)$/) {   
		return $1;
	} else {   
		return 0;   
	}   
}

sub mod_pop_connect {   
	if ($logs[$_[0]]{'logline'} =~ /in.ipop.*?connect from (.*?)$/) {   
		return $1;
	} else {   
		return 0;   
	}   
}

sub mod_su {   
	if ($logs[$_[0]]{'logline'} =~ /\(su\) session.*?for user (.*?) by (.*?)\(/) {   
		return ($1,$2);
	} else {   
		return 0;   
	}   
}

sub mod_failed_login { 
	if ($logs[$_[0]]{'logline'} =~ /FAILED LOGIN.*?FROM (.*?) FOR (.*?)\,/) { 
		return ($1, $2); 
	} else { 
		return 0; 
	} 
 } 

sub mod_bad_rsh {  
	if ($logs[$_[0]]{'logline'} =~ /rshd.*?Connection from (.*?) on illegal port/ ) {  
		return $1;
	} else {  
		return 0;  
	}  
}

sub mod_bad_rlogin {   
	if ($logs[$_[0]]{'logline'} =~ /rlogind.*?Connection from (.*?) on illegal port/ ) {   
		return $1;
	} else {   
		return 0;   
	}   
} 

1;

